/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Thu Jan  2 15:07:02 CET 2003
    copyright            : (C) 2003 by Robert Penz
    email                : robert.penz@outertech.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#include <vclib.h>

int main(int argc, char *argv[])
{
  struct virtualcd_info vc_info;
  int i;


  /* print usage messages if no parameter is given*/
  if ((argc == 1) || ((strncmp(argv[1], "--help", 6)==0)))
  {
    printf("vcsetup version 0.4 alpha\n");
    printf("Usage:   load cd: vcsetup device cue-file | e.g. vcsetup /dev/virtualcd foobar.cue\n");
    printf("       unload cd: vcsetup -d device | e.g. vcsetup -d /dev/virtualcd\n");
    printf("          status: vcsetup -s\n");
    exit(0);
  }

/*  for(i = 0; i < argc ; i++)
    printf("%s\n",argv[i]);

  fflush(NULL); */
  /* print the proc stuff */

  if (strncmp(argv[1], "-s", 2)==0)
  {
    FILE *File;
    char sLine[1024];

    /* open the proc file */
    File = fopen ("/proc/virtualcd", "r");
    if (File == NULL)
    {
      perror("\nCould not open /proc/virtualcd");
      printf("\n");
      exit(1);
    }

    while(!feof(File))
    {
      if (fgets( sLine, 1024, File))
        printf("%s",sLine);
    }
    return EXIT_SUCCESS;
  }


  if (strncmp(argv[1], "-d", 2)==0)
  {
    /* unload */
    switch (unload_virtualcd (argv[2]))
    {
      case VC_ALL_OK:
          printf("cd successfully unloaded\n");
          break;
      case VC_IOCTL_ERROR:
          perror("\nioctl error");
          printf("\n");
          break;
      case VC_COULD_NOT_OPEN_DEVICE:
          perror("\nCould not delete the device");
          printf("\n");
          break;
      default:
          perror("\nunhandled error");
          printf("\n");
    }
    return EXIT_SUCCESS;
  }

  if (strncmp(argv[1], "-", 1)==0)
  {
    printf("parameter unknown - use --help");
    printf("\n");
    return EXIT_SUCCESS;
  }

  {
    switch (load_virtualcd (argv[1], argv[2], &vc_info))
    {
      case VC_ALL_OK:
          printf("cd successfully loaded\n");
          break;
      case VC_COULD_NOT_OPEN_BIN_FILE:
          perror("\nCould not open the bin file");
          printf("\n");
          break;
      case VC_COULD_NOT_OPEN_CUE_FILE:
          perror("\nCould not open the cue file");
          printf("\n");
          break;
      case VC_COULD_NOT_OPEN_DEVICE:
          perror("\nCould not open the device");
          printf("\n");
          break;
      case VC_IOCTL_ERROR:
          perror("\nioctl error");
          printf("\n");
          break;
      case VC_ERROR_READING_CUE_FILE:
          perror("\nError reading the cue file");
          printf("\n");
          break;
      case VC_ERROR_STATTING_CUE_FILE:
          perror("\nCould not statt the cue file");
          printf("\n");
          break;
      default:
          perror("\nunhandled error");
          printf("\n");
    }
  }

  return EXIT_SUCCESS;
}
