/***************************************************************************
                          vclib.h  -  description
                             -------------------
    begin                : Thu Jan 2 2003
    copyright            : (C) 2003 by Robert Penz
    email                : robert.penz@outertech.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

typedef struct track
{
   unsigned short mode;
   unsigned short minute;
   unsigned short second;
   unsigned short frame;

   /* (min*60 + sec) * 75 + fps   */

   unsigned long start_sector;

   /* = the sizes in bytes off all tracks bevor this one */
   /* its needed if there are mode1 tracks befor the mpeg tracks */
   unsigned long start_offset;

   /*   unsigned char num[3]; */
} tTrack;


struct virtualcd_info {
	tTrack          tracks[100];
	unsigned int    ffd;
 	int             nTracks; /* number of tracks on the cd */
  char            comment[256];
};


#define VIRTUALCD_LOADCD      0x5400  /* load the virtual cd */
#define VIRTUALCD_UNLOADCD    0x5401  /* unload the virtual cd*/

#define UNKNOWN -1
#define AUDIO 0
#define MODE1 1
#define MODE2 2
#define MODE1_2352 10
#define MODE2_2352 20
#define MODE1_2048 30
#define MODE2_2336 40



/* Some generally useful CD-ROM information -- copy and past from include/linux/cdrom.h */
#define CD_MINS              74 /* max. minutes per CD, not really a limit */
#define CD_SECS              60 /* seconds per minute */
#define CD_FRAMES            75 /* frames per second */
#define CD_SYNC_SIZE         12 /* 12 sync bytes per raw data frame */
#define CD_MSF_OFFSET       150 /* MSF numbering offset of first frame */
#define CD_CHUNK_SIZE        24 /* lowest-level "data bytes piece" */
#define CD_NUM_OF_CHUNKS     98 /* chunks per frame */
#define CD_FRAMESIZE_SUB     96 /* subchannel data "frame" size */
#define CD_HEAD_SIZE          4 /* header (address) bytes per raw data frame */
#define CD_SUBHEAD_SIZE       8 /* subheader bytes per raw XA data frame */
#define CD_EDC_SIZE           4 /* bytes EDC per most raw data frame types */
#define CD_ZERO_SIZE          8 /* bytes zero per yellow book mode 1 frame */
#define CD_ECC_SIZE         276 /* bytes ECC per most raw data frame types */
#define CD_FRAMESIZE       2048 /* bytes per frame, "cooked" mode */
#define CD_FRAMESIZE_RAW   2352 /* bytes per frame, "raw" mode */
#define CD_FRAMESIZE_RAWER 2646 /* The maximum possible returned bytes */
/* most drives don't deliver everything: */
#define CD_FRAMESIZE_RAW1 (CD_FRAMESIZE_RAW-CD_SYNC_SIZE) /*2340*/
#define CD_FRAMESIZE_RAW0 (CD_FRAMESIZE_RAW-CD_SYNC_SIZE-CD_HEAD_SIZE) /*2336*/

/* vclib error messages */

#define VC_ALL_OK                         0
#define VC_COULD_NOT_OPEN_BIN_FILE        1
#define VC_COULD_NOT_OPEN_CUE_FILE        2
#define VC_COULD_NOT_OPEN_DEVICE          3
#define VC_IOCTL_ERROR                    4  /* use "errno" for the excact error e.g. perror function */
#define VC_ERROR_READING_CUE_FILE         5
#define VC_ERROR_STATTING_CUE_FILE        6
#define VC_COULD_NOT_DELETE_DEVICE        7


extern int load_virtualcd (const char *device, const char *file, struct virtualcd_info *vc_info);
extern int unload_virtualcd (const char *device);
